#include <stdio.h>
#include <math.h>
#include <assert.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

void write_modelinfo_f_(int *fd, float *theta, float *phi, float *radlist, int *numhnode, int *numrnode) 
{ /* this program outputs a binary file containing a 3D model
   * values as layers of values.  Called from fortran programs
   */ 
   int i, j, n;
   float theta_phi[2];
   char filename[256];

   printf("output file name:\n");
   scanf("%s", filename);
   *fd = creat(filename, 0666);
   printf("*fd = %d\n", *fd);
   printf("numhnode = %d, numrnode = %d\n", *numhnode, *numrnode);
   n = write(*fd, numhnode, sizeof(int));
   n = write(*fd, numrnode, sizeof(int));
   for(i=0; i< *numhnode; i++){
	theta_phi[0] = theta[i];
	theta_phi[1] = phi[i];
	if(i<20) printf("%f %f\n", theta_phi[0], theta_phi[1]);
	write(*fd, theta_phi, sizeof(theta_phi));
   }
   for(i=0;i<20;i++) printf("%f\n", radlist[i]);
   write(*fd, radlist, *numrnode*sizeof(float));
}

void write_layer_f_(int *fd, float *layer, int *numhnode) 
{ /* writes a layer of model values into a binary file for 3D model conversion */
   int n;
   printf("numhnode = %d, layer[0] = %f\n", *numhnode, layer[0]);
   n = write(*fd, layer, *numhnode*sizeof(float));
}

void closefd_(int *fd)
{
	close(*fd);
}
