#ifndef CONST_HEADER
#define	CONST_HEADER
/* matrix format, since matrix may be read/write by c code or c++ code, we need to
   make sure the following definitions are consistent with the definitions in
   /scratch/troiks14/su/lib/wscpp/econst.h
*/
#define	IPM_GEN		0	/* matrices in general, not related to any model*/
#define	IPM_BSP_R	1	/* related to 2D or 3D B-spline model, rknots described as radius*/
#define	IPM_BSP_D	2	/* as above, but rknots described as depth*/
#define	IPM_SPH_B	3	/* related to spherical harmonic model, radial func described by Bspline*/
#define	IPM_SPH_C	4	/* as above, but radial func described by Chebyshev polynomial*/
#define	IPM_BSP_R_COM	5	/* 2d or 3d B-spline, joint models (high order regional + lower order
					    whole earth*/
#define IPM_BSP_R_TOPO     6	/* 2D or 3D B-spline model, rknots described as radius, also contain
				 boundary perturbations */

#define   BSP_R_MAT_NEW   11	/* 3D tvl time B-spline model, NEW FORMAT */
#define   BSP_R_TOPO_410  61 	/* 2d 410 topo + 3D b-spline, knots described as radius */
#define   BSP_R_TOPO_660  62 	/* 2d 670 topo + 3d b-spline, knots described as radius */
#define   BSP_R_TOPO_ALL  63 	/* 3D b-spline + 410 + 670, radius as knots */

#define 	MATRIX_GEN  		0  
#define 	MATRIX_SYM  		1    /* symmetric matrix */
#define 	MATRIX_SPARSE  		2    /* sparse matrix */
#define 	MATRIX_SPARSE_SYM  	3    /* sparse symmetric matrix */



#endif

