#include <stdio.h>
#include <math.h>

void read_3d_damp_(float *atd, float *dmat, int *numatd, char *comment)
{  /* read 3D damping matrix in Weijia's format, Jeff Gu, 1999
    * this is very similar to ReadIpm of BS_IPM with the exception
    * of  1.  format is 1 which is different
    *	  2.  a comment field exists
    */
 int i,fd,n_read;
 int format, numata, numgpt;
 float theta_phi[2];
 char buf[132],filenm[132];

  printf("Name of 3D matrix:\n");
  GetLine(buf,132);
  sscanf(buf,"%s",filenm); 
  printf("....Reading damping matrix from file: %s\n", filenm);

  fd=SysOpen(filenm,0);
  n_read=read(fd,&format,sizeof(int));
  read(fd,comment,sizeof(char)*120);
  printf("format = %d, comment = %s\n", format, comment);
  format=11;	/* change Weijia's format to the ATA format */
  read_bs_ipm_param(fd, format);  
  read(fd,numatd,sizeof(int));
   printf("......reading damping ata......\n");

   numata=(*numatd*(*numatd+1))/2;
   n_read=read(fd,dmat,numata*sizeof(float));
   if(n_read!=(numata*sizeof(float))){
      printf("Error in read_ipm_, unable to read ata\n");
      exit(-1);
   }

   printf("......reading atd......\n");

   n_read=read(fd,atd,*numatd*sizeof(float));
   if(n_read!=(*numatd*sizeof(float))){
     printf("Error in read_ipm_, unable to read atd\n");
     exit(-1);
   }
   IPMStats(dmat,atd,*numatd);
   close(fd);
}
