#include <stdio.h>
#include <math.h>
#include "wsc.h"
#include "const.h"

void read_sym_matrix_(float *amat, int *row, char *comment)
{
int i,n_read;
int iformat;
int fd, num, num1,col,itemp;
char buf[132],filenm[132];

   printf("Matrix file:\n");
   GetLine(buf,132);
   sscanf(buf,"%s",filenm); 

   fd=SysOpen(filenm,0);

   n_read=read(fd,&iformat,sizeof(int));

   if(iformat!=MATRIX_SYM){
     printf("Reading a matrix of wrong format\n");
     exit(1);
   }
   n_read=read(fd,comment,132);	/* 132 is the number of chars for the comments */

   read(fd,&itemp,sizeof(int));	/* number of  rows */
   if(itemp>*row){
	printf("Not enough memory for array amat in read_sym_matrix_.\n");
	printf("row max = %d\n",*row);
	printf("row  = %d\n",itemp);
        exit(1);
   }
      
   read(fd,&col,sizeof(int));	/* number of  cols */
   if(col!=itemp){
	printf("Error in function read_sym_matrix_\n");
        printf("row != col\n");
        printf("row = %d\n", itemp);
        printf("col = %d\n", col);
   }
   read(fd,&num,sizeof(int));	/* total number of elements */

   *row=col;

   num1=(col+1)*col/2;

   if(num!=num1){
	printf("Number of rows = %d\n",*row);
	printf("Number of columns = %d\n",col);
	printf("num1 = %d\n",num1);
	printf("Error in function read_sym_matrix_\n");
	exit(1);
   }

  printf("......reading A matrix ......\n");
  read(fd,amat,num*sizeof(float));

  printf("Number of rows = %d\n",*row);
  printf("Number of columns = %d\n",col);
/*
  for(i=0;i<num;i++){
      if(amat[i]>10.0){
         printf("i=%d amat[i]=%g\n");
      }
      printf("%10.2g ",amat[i]);
      if((i+1)%10==0){
          printf("\n");
      }

  }
*/
}
