/* conv_model.c */
#include <stdio.h>
#include <math.h>
#include <assert.h>
#include <string.h>
#include "./sulib/wslib.h"
#define maxnode 100000
float CalVel(MODEL, SPHERE);
void SphBkernel(float**, SPHERE, float, int, float*, int*, int*);
void FormMatrix(float*,int, float*, int*,
		int, int, float, float*, float*, float*, int*, int);
void write_xyz2grd(char *gridfl, float dlon,float dlat,
  float lonmin,float lonmax,float latmin,float latmax, char *);
void GetGrid_randsplit(float *xlat, float *xlon, float *dlat,float *dlon,
	float *latmin, float *latmax,float *lonmin,float *lonmax, int *ndata);
void Color_Pt_Smooth_Vel(float absmax,float ymin, float second_max);
void SaveGrid2D(float **grid,float bllat,float bllon,float trlat,float trlon,
		float r, int row, int col);
int Geomap_save_grid(float **grid, int row,int col,float depth);

main()
{
MODEL model1,model2;
float lat,lon;
float ddmax, ddmin, average, dlat, dlon;
float latmin,latmax,lonmin,lonmax;
float **au,*ar,*br,*xlat,*xlon;
float **bu,**bl;
float r,dr,dd,rtop,rbot,B[4],*HB,hh,xx,*ha,**hker,**rker;
float *ata,*atd,*arow,vsp2,vpremp,vprems;
float *rr, depth;
int *irr,outfmt,dataopt;
int i,j,k,l,nnode,nrad, nrad_um,nrad_lm,ndata,*ia,*ihb,iht,mrpt,*iar;
int numata,numatd,nrdat_um, nrdat_lm,nrdat,**iker,nono,choice;
int nrow, ncol;
int fdin;
SPHERE s;
FILE *fp;
char str[132], depthfile[256], gridfile[256], outfile[256], binfile[256];
PREM   *par;
float **grid, *layer;

  printf("This program will plot a map at a given depth\n");
  printf("for a split B-spline model---model option 27.\n");
  printf("This program will plot a map at a given depth\n");
  mrpt=1000;			/* max points in r direction to cal kernels */
  
  GetModel(&model1,TRUE);	/* read in spherical harmonic model */
  
  printf("***************************************\n\n\n");
  printf("Now choose The split B-spline model.\n");
  printf("This model needs to provide the coordinates of the horizontal\n");
  printf("grids and radial knots. The model coefficients are also required.\n");
  nnode=model1.lmaxum;
  nrad_um=model1.kmaxum;
  nrad_lm=model1.kmaxlm;
  nrad = nrad_um+nrad_lm;
  au=model1.au;
  ar=model1.ar;
  br=model1.br;
  printf("Total kmax=%d\n", nrad);
  printf("UM kmax=%d\n",nrad_um);
  printf("LM kmax=%d\n",nrad_lm);
  printf("number of nodes=%d\n",nnode);
/*
 * calculate kernels in radial direction
 */
  rker=matrix(1,mrpt,1,4);	/* to save kernels */
  rr  = vector(1, mrpt);
  irr =IntVec(1,mrpt);

  printf("Output format:\n");
  printf("--------------------------------------------\n");
  printf("1. lat, lon, value \n");
  printf("2. lon, lat, value \n");
  printf("3. gmt format (colon,lat) \n");
  printf("4. save in GEOMAP grid format \n");
  printf("5. binary model values for geo3d plotting \n");
  GetLine(str, 132);
  sscanf(str,"%d", &outfmt);
  assert(outfmt>0 && outfmt<6);
  printf("outfmt = %d\n", outfmt);
  if(outfmt != 4){
  	ReadDepth(rr, &nrdat);
  }else{
 	printf("enter the depth:\n");
	GetLine(str,132);
	sscanf(str, "%f", &rr[1]);
	depth=rr[1];
	rr[1]=6371.-rr[1];
	nrdat=1;
  }
/*  calc kernels for LOWER AND UPPER MANTLE */
  nrdat_lm = nrdat_um = 0;
  for(k=1;k<=nrdat;k++){	/* loop for every region */
        r=rr[k];
        irr[k]=find_region_split(r,nrad_lm,model1, 0);
	if(irr[k]>0) {	/* lower mantle depth */
        	BSplKer(B,r,br,nrad_lm);
		nrdat_lm ++;
	}else{		/* upper mantle depth */
        	irr[k]=find_region_split(r,nrad_um,model1, 1);
		printf("irr[k] = %d\n", irr[k]);
		if(irr[k] < 0) {
			printf("depth out of range, exit...\n");
			exit(-1);
		}
        	BSplKer(B,r,ar,nrad_um);
		irr[k] += nrad_lm;
		nrdat_um ++;
	}
        for(i=0;i<4;i++) {
		rker[k][i+1]=B[i];
		printf("i=%d  B[i]=%f\n", i, B[i]); 
	}
        printf("k = %d, r = %f, irr[k]=%d\n",k ,r, irr[k]);
  }
  printf("total radial points in Lower Mantle=%d\n",nrdat_lm);
  printf("total radial points in Upper Mantle=%d\n",nrdat_um);
  
/*
 * read data
 */
  xlat=vector(1,maxnode);
  xlon=vector(1,maxnode);
  GetGrid_randsplit(xlat,xlon,&dlat,&dlon,&latmin,&latmax,&lonmin,&lonmax,&ndata);
  printf("total surface points=%d, array size=%d\n", ndata,maxnode);
  hker=matrix(1,ndata,1,20);	/* to save horizontal kernels for each data point */
  iker=imatrix(1,ndata,0,20);	/* index */
  ihb=IntVec(1,20);
  HB=vector(1,20);
  hh=model1.rmid;
/*
 * cal kernels in horizontal direction
 */
  
  printf("calculating horizontal kernels\n");
  for(i=1;i<=ndata;i++){		  /* loop for all the nodes */
      lon=xlon[i];
      lat = xlat[i];
      while(lon>180.0) lon=lon-360.0;
      s=Geo2Sph(lat,lon,1.0);
      SphBkernel(au,s,hh,nnode,HB,ihb,&iht);  
      iker[i][0]=iht;   /* iker[i][0] stores the total number of non-zero elements */
      for(j=1;j<=iht;j++){
          iker[i][j]=ihb[j];
          hker[i][j]=HB[j];
      }
  }
/*
 * calculate model values at different depths
 */
  if(outfmt != 5 && dlat > 0.0 && dlon > 0.0) {
  	nrow=(int)((latmax-latmin)/dlat)+1;
  	ncol=(int)((lonmax-lonmin)/dlon)+1;
  	printf("nrow=%d, ncol=%d, ndata=%d\n", nrow, ncol, ndata);
  	grid=matrix(1,nrow,1,ncol);  /* grid of values for given depth*/
  }else{
	layer = vector(1, ndata);
  }
  if(outfmt!=4){
	printf("output file name:\n");
	GetLine(outfile,256);
	if(outfmt != 5) fp = fopen(outfile, "w");
	else   write_modelinfo_c(outfile, &fdin, xlat, xlon, &rr[1], ndata, nrdat);
  }
  for(i=1;i<=nrdat;i++){ /* loop for every region */
      ddmax=-9999999.;
      ddmin=99999999.;
      average=0.0;
      r=rr[i];
      printf("processing r=%f model=%d\n",r,model1.mod);
      k=1;
      l=1;
      for(j=1;j<=ndata;j++){	/* loop for all the nodes */
      	  lon=xlon[j];
      	  while(lon>180.0) lon=lon-360.0;
	  lat=xlat[j];
          s=Geo2Sph(lat,lon,1.0);
	  if(irr[i]<=nrad_lm) {
          	dd=CalBSVal_LM(model1, rker[i],irr[i],hker[j],iker[j],
				nrad_lm,nnode);     
	  }else {
          	dd=CalBSVal_UM(model1, rker[i],irr[i]-nrad_lm,hker[j],iker[j],
				nrad_um,nnode);     
	  }
	  if(outfmt != 5 && dlat > 0.0 && dlon > 0.0) {
	  	grid[k][l]=dd;	/* save data in row and column format with avg */
	  }else{
		layer[j]=dd;	/* save horizontal values at a particular depth */
	  }
	  if(dd>ddmax) ddmax=dd;
	  if(dd<ddmin) ddmin=dd;
	  if(l==ncol) {
		l=0;
		k++;
	  }
	  average+=dd;
	  l++;
      }
      average /= ndata;
      printf("average velocity of the depth=%f\n", average);
      if(outfmt == 5) {
	write_layer(fdin, &layer[1], ndata);
      }else{
/* below subtracts average and print out */
      	k=1;
      	l=1;
	printf("dlat = %f, dlon = %f\n", dlat, dlon);
      	for(j=1;j<=ndata;j++){
	  switch(outfmt) {
	  case 1:
		if(dlat < 0.0 && dlon < 0.0) {
			fprintf(fp, "%f %f %f\n", xlat[j],xlon[j],layer[j]-average);
		}else{
			fprintf(fp, "%f %f %f\n", xlat[j],xlon[j],grid[k][l]-average);
		}
		break;
	  case 2:
		if(dlat < 0.0 && dlon < 0.0) {
			fprintf(fp, "%f %f %f\n", xlon[j], xlat[j], layer[j]-average);
		}else{
			fprintf(fp, "%f %f %f\n", xlon[j], xlat[j], grid[k][l]-average);
		}
		break;
	  case 3:
		if(dlat < 0.0 && dlon < 0.0) {
			fprintf(fp, "%f %f %f\n", xlon[j], xlat[j], layer[j]-average);
		}else{
			fprintf(fp, "%f %f %f\n",xlon[j],xlat[j],grid[k][l]-average);
		}
		break;
	  case 4:
		if(l==ncol) {
			printf("xlat=%f, xlon=%f, k=%d l=%d, grid=%f\n", 
			xlat[j], xlon[j], k, l, grid[k][l]-average);
			l=0;
		}
		break;
	  default:	
		break;
	  }
	  if(l==ncol) {
		l=0;
		k++;
	  }
          l++;
      	}
      }
  }
	printf("junk!!!\n");
  if(outfmt != 4 && outfmt != 5) {
	fclose(fp);
  	printf("maximum = %f, minimum = %f, average = %f\n", ddmax,ddmin,average);
  	printf("colon min = %f, colon min = %f, colat min = %f,colat max = %f\n", lonmin, lonmax, latmin, latmax); 
  	printf("dlat = %f, dlon = %f\n", dlat,dlon);
  	printf("\n output file %s created ...\n", outfile);
  } else if(outfmt == 4) {
	Geomap_save_grid(grid,nrow,ncol,depth);
  } else if(outfmt == 5) {
	close(fdin);
	free_vector(layer, 0, ndata);
  } 
                           
/*
 * release allocated memories
 */  
  free_vector(HB,1,20);
  free_matrix(rker,1,mrpt,1,4);	/* to save kernels */
  if(outfmt==4) free_matrix(grid,1,nrow,1,ncol);
  free_vector(rr,1,mrpt);
  free_ivector(irr,1,mrpt);
  free_vector(xlat,1,maxnode);
  free_vector(xlon,1,maxnode);

  ReleaseModel(&model1);

}

void SphBkernel(float **au, SPHERE s1, float hh, int nnode, float *HB, int *ihb, int *iht)
{
float h2=2.0*hh,delta,fac;
int i;
SPHERE s0;

   s0.r=1.0;
   *iht=0;
   for(i=1;i<=nnode;i++){
      s0.theta=au[1][i];
      s0.phi  =au[2][i];
      delta=ArcDist(s0,s1);
      if(delta<=h2){
         (*iht)++;
         HB[*iht]=fdelta(delta,hh);
         ihb[*iht]=i;
      }
   }
}

float CalVel(MODEL model, SPHERE s)
{
float v,*ar,*br, *ylm,smph[100],cmph[100];
int   lmax;

  lmax  = model.lmaxum;
  ar    = model.ar;
  br    = model.br;
  ylm   = model.ylm;
  
  Ylm(lmax,s.theta,ylm);
  CSmPhi(s.phi,cmph,smph,lmax);
  v=SumSurCoeff(model,ar,br,lmax,cmph,smph,ylm);
  return v;
}

void FormMatrix(float *rker,int irr, float *hker, int *iker,
		int nrad, int nrad_lm, float dd, float *ata, float *atd, float *arow, int *iar, int nnode)
{
int i,i0,i1,j,k,m,ii,jj;
float rowi;

   i0=1;
   i1=4;
   if(irr==1)i0=2;
   if(irr==nrad_lm-1) i1=3;
   if(irr==nrad_lm+1) i0=2;
   if(irr==nrad-1)i1=3;
   
   for(k=0,i=i0;i<=i1;i++){
      m=(irr-3+i)*nnode;
      for(j=1;j<=iker[0];j++){
          k++;
          arow[k]=rker[i]*hker[j];
          iar[k]=m+iker[j];
      }
   }
   
   for(i=1;i<=k;i++){		/* add to ata and atd */
       ii=iar[i];
       rowi=arow[i];
       atd[ii]+=rowi*dd;
       for(j=1;j<=k;j++){
           jj=iar[j];
           if(jj<=ii)ata[jj+ii*(ii-1)/2]+=arow[j]*rowi;
       }
   }
}


int Geomap_save_grid(float **grid,int row,int col,float depth)
{
float rr,bllat,bllon,trlat,trlon;
int i,j;
float **grid1;

  grid1=matrix(0,row-1,0,col-1);
  
  rr=RADIUS-depth;
  
  bllat=-90.0;
  bllon=0.0;
  trlat=90.0;
  trlon=360.0;
  
  for(i=0;i<row;i++){
      for(j=0;j<col;j++){
          grid1[i][j]=grid[i+1][j+1];
      }
  }
  SaveGrid2D(grid1,bllat,bllon,trlat,trlon,rr,row,col);
}

void GetGrid_randsplit(float *xlat, float *xlon, float *dlat,float *dlon,
	float *latmin, float *latmax,float *lonmin,float *lonmax, int *ndata)
{
/* this one allows the split at any meridian in the whole mantle:
 * i.e., not from 0-360,  rather 45-405. Note xlon is the colongitude
 * which can be greater than 2*PI.
 */
int dataopt,nlat,nlon,i,j,k;
float lat, lon, lat1, lon1;
FILE *fp;
char s[MAXSTR];
char gridfile[256];

  printf("surface point:\n");
  printf("------------------------------------\n");
  printf("1. enter by keyboard\n");    
  printf("2. enter from a file\n");
  printf("3. enter a range and increment\n");
  printf("enter:\n");
  GetLine(s,MAXSTR);
  sscanf(s,"%d", &dataopt);
  assert(dataopt>0 && dataopt<4);
  *dlat = - 99999.0;
  *dlon = - 99999.0;
	
  switch (dataopt) {
	case 1:
		printf("enter longitude and latitude:\n");
		GetLine(s,MAXSTR);
		sscanf(s, "%f %f", &lon,&lat);
		xlat[1]=lat;
		xlon[1]=lon;	
		*ndata=1;
		break;
	case 2:
  		printf("enter longitude--latitude grid file:\n");
		GetLine(s,MAXSTR);
		sscanf(s, "%s", gridfile);
  		fp=fopen(gridfile, "r");
    		i=1;
    		while(fscanf(fp,"%f %f",&lon,&lat)!=EOF){
       			xlat[i]=lat;
       			xlon[i]=lon;
       			if(i>=100000){
          			printf("too many data points\n");
          			exit(1);
       			}
			i++;
   	 	}
    		*ndata=i-1;
    		printf("total surface node points = %d\n",*ndata);
    
 	 	fclose(fp);
		break;
	case 3:
		printf("latitude range (min, max, # point):\n");
		GetLine(s,MAXSTR);
		sscanf(s,"%f %f %d", latmin,latmax,&nlat);
		printf("colongitude range (min, max, # point):\n");
		GetLine(s,MAXSTR);
		sscanf(s,"%f %f %d", lonmin,lonmax,&nlon);
		assert(*latmax>*latmin && *lonmax>*lonmin);
		k=1;
		lat1=*latmin;
		*dlat=(*latmax-*latmin)/(nlat-1);
		*dlon=(*lonmax-*lonmin)/(nlon-1);
		printf("dlat = %f, dlon = %f\n", *dlat, *dlon);
	 	for(i=1;i<=nlat;i++){
			lon1=*lonmin;
			for(j=1;j<=nlon;j++){
				xlon[k]=lon1;
				xlat[k]=lat1;
				k++;
				lon1+=*dlon;
			}
			lat1+=*dlat;
		}
		*ndata=k-1;
		break;
	default:
		break;
  }
}
