	program sphpower
c       The program interpolates the data input by using the
c	spherical harmonic expansion. It is designed
c	to calculate the model rms, power spectra at a 
c 	specific depth, or depths.
	implicit real*4 (a-h, o-z)
	parameter (lsize = 36 )       ! harmonic degree
	parameter (nunk = (lsize+1)**2)
	parameter (idsize = 5000)
	parameter (ilata = nunk*(nunk+1)/2)
c	
	real*4  lat, phi(idsize), dat(idsize),
     *         theta(idsize), pi,misfit, truerms,realchisq,
     *		 long, xsqr,syndat, modelsize, power,range	
	real*4 datlat(idsize), datlon(idsize)
	real*4 ylm(0:lsize, 0:lsize),ata(ilata),
     *        rowa(nunk),rmstop, rmsbot,
     *		atd(nunk),gstore(ilata), ytemp(nunk),x(nunk),
     *		damp,deldamp, a(idsize,nunk)
	real*4   modelrms, harmpow, harmpow0, datavg
	integer*4 filecounter
        integer*4 idsize,lsize, nunk, ilata, idim,ilsq, lmx
        integer*4 nono, ndat,icount,imodel,itrial
	integer*4  immax, dampcoef(nunk)
	character*256 datfl, outfl, specfl, atafl
	character*1 switch1, switch2, switch3 

	pi = 3.14159265359
c	read in the info from the datafile
	print*, 'enter the datafile name:'
	read(*,*) datfl
	i = 1
	open(1, file=datfl, type ='old')
c	read in data and convert lat and long to theta, phi
	avgdat = 0.0
10	read(1, *, end=20) lat, long, dat(i)
        datlat(i) = lat
        datlon(i) = long
	lat=pi/2.0-lat/(180.0)*pi
	theta(i) = lat
	if(long.lt.0.0) long = 360.0+long
	phi(i) = long*pi/180.0
	avgdat=avgdat+dat(i)
	i = i+1
	goto 10
20	ndat=i-1
	print*, '# of data points:' , ndat
	close(1)
	print*, 'maximum angular harmonic degree l :'
	read*, lmx 
	ilsq=(lmx+1)**2
	idim=ilsq*(ilsq+1)/2

c  initialize all the arrays.
	print*, 'initializing arrays...'
	do i =0, lmx
	   do j = 0, lmx
		ylm(i,j) = 0.0
	   end do
       end do
	do i=1, ilsq
		atd(i) = 0.0
		dampcoef(i)=0
		rowa(i)=0.0
	end do

	do i=1, idim
		ata(i)=0.0
		gstore(i)=0.0
	end do 
	do i=1,ndat
	   do j=1, ilsq
	      a(i,j)=0.0
	   end do
	end do
	print*, ' '
	print*, ' ' 
c	print*, 'desired chi-square per data:'
c	read*, xsqr
	xsqr = 0.00001
	xsqr=xsqr*ndat
c	print*,'initial damping,increment and # trials:'
c	read*, damp, deldamp, itrial
c	print*,'allowed percentage uncertainty in desired Xsq:'
c	read*, range

	print*, 'damping parameter:'
	read(*,*) damp
c`	avgdat = avgdat/(ndat-1)
c	damp = abs(avgdat)/(ndat-1)
c	print*, 'initial damping = ', damp
c	deldamp = avgdat/100.
c	damp=0.0	! assume that the model is smooth
c	deldamp=0.0
	print*, 'initial damping = ', damp
	itrial  = 1
	range = 200000

c	print*, 'file to save power spectrum?'
c	read*, switch2
	print*, 'output file for spherical harmonics:'
	read*, outfl
	open(2, file=outfl(1:lnblnk(outfl))//'.sph', type='unknown')

	switch2 = 'y'
	if(switch2.eq.'y'.or.switch2.eq.'Y') then
	     open(4, file=outfl(1:lnblnk(outfl))//'.pow', type='unknown')
	end if
	rmstop = xsqr+xsqr*(range)/100.0
	rmsbot=  xsqr-xsqr*(range)/100.0
	print*,' '
	print*, ' '
	print*, 'calculating...' 
	do 60 i=1, ndat
	  icol=0
	  call spherical(theta(i), lmx, ylm,lsize)

	  do j=0, lmx
	    do k=0, j
	     if(k.eq.0)  then
	         icol = icol +1
	         rowa(icol)=ylm(j,0)
	     else	    
	       icol = icol +1
	       rowa(icol)=ylm(j,k)*cos(k*phi(i))
	       icol=icol +1
	       rowa(icol)=ylm(j,k)*sin(k*phi(i))
	     endif
	    enddo
	  enddo
	  k1=0
	  do i1=1,icol
	     atd(i1)=atd(i1)+rowa(i1)*dat(i)
	     do j1=1,i1
	        k1=k1+1
	        ata(k1)=ata(k1)+rowa(i1)*rowa(j1)
		if(i1.eq.j1) then
	           ata(k1)=ata(k1)+damp
		endif
	     enddo
	  enddo
60	continue
	idamp=1
	imodel=1
c below will find the damping ratio for each degree.
	icount=0
	immax=0
	do il=0, lmx
	    immax=2*il+1
	    do im=1, immax
	        icount=icount+1
	        dampcoef(icount) = (il)*(il+1)
	    end do
       end do

c  Below will damp the diagonal and calculate least sq solution x.
70	if(idamp.gt.itrial) goto 80
	icount=0 
	k1=0    
	  do ix=1, icol
	     do iy=1, ix
	        k1=k1+1
	        if(iy.eq.ix) then
	            icount=icount+1
	            ata(k1)=ata(k1)+damp*float(dampcoef(icount))
	        end if
	     end do
	   end do
	call choles(ata, gstore, atd,ytemp,x,ilsq,nono)
	print*, 'nono = ', nono 
	truerms=0.0
	realchisq=0.0
        write(*,*) 
	do irow=1, ndat
	    misfit =0.0
	    syndat = 0.0
	    do icl=1, icol
	        syndat = syndat+a(irow,icl)*x(icl)
	    end do
	    misfit =( syndat-dat(irow))**2
	    realchisq = (misfit)+realchisq
	    truerms= truerms+abs(syndat-dat(irow))
c	    print*, datlon(irow), datlat(irow), syndat
	end do
	    truerms=truerms/float(ndat)
	    if(realchisq.gt.rmstop.or.realchisq.lt.rmsbot) then
c	       print*, '**DAMPING             :', damp 
	       print*, '**ACTUAL  chi-square  :',realchisq/ndat
c	       print*, '**RMS MISFIT DESIRED  :', rms
c	       print*, '**RMS MISFIT OBTAINED :', truerms
	       print*, '**************************************'
c	       write(3,*) imodel, modelsize
c	       imodel=imodel+1
	       damp=deldamp+damp
	       idamp=idamp+1
	       goto  70
	    else
	       goto 80
	    end if
	
c
80	print*,'      **Statistical Analysis**'
	print*,'*******************OUTPUT WINDOW***************'
	print*,'     **NUMBER OF DATA      :', ndat
	print*,'     **DEGREE L USED       :', lmx
	print*,'     **DAMPING             :', damp
	print*,'     **ACTUAL  chi-square  :', realchisq/ndat
c	print*,'     **MODEL SIZE          :', modelsize
	print*,'***********************************************'

c below saves the rms of the model
	do i=0, lmx
	enddo
	if(switch2.eq.'y'.or.switch2.eq.'Y') then
	      k1=0
	      modelrms = 0.0
	      do il=0, lmx
		  harmpow = 0.0
	          power=0.0
	          do im=0, il
	              if(im.eq.0) then
	                  k1 = k1+1
	                  power = power + x(k1)**2
			  harmpow0 = power
	              else
	                    k1=k1+1
	      		    power= power + x(k1)**2
			    modelrms = modelrms+power
	      		    k1=k1+1
	      		    power=power+x(k1)**2
			    modelrms = modelrms+power
			    harmpow = harmpow + power
	      	      end if
	      	   enddo
	      	   write(4,*) il, power
	      enddo
c	      modelrms = sqrt(modelrms - x(1)*x(1))
c	      write(99, *) modelrms
	endif

	k = 0
	do l=0,lmx
	   k=k+1
	   write(2,"(2i4,2e12.4)")l,0,x(k),0.0
	   do m=1,l
	      k=k+1
	      write(2,"(2i4,2e12.4)")l,m,0.5*x(k),-0.5*x(k+1)
	      k=k+1
	   enddo
	enddo
	print*, 'output file', outfl, ' and ', specfl, ' have been created...'
	close(2)

	goto 100
90	print*, 'CHI-SQUARE NOT ACCEPTABLE, NO OUTPUT FILE CREATED..'
100     close(4)
c       if(switch3.eq.'Y'.or.switch3.eq.'y')  close(8)
	end


c.......................................................................
c.....ylm.f
c     This subroutine is to compute the spherical harmonics
c     see "Numberical Recipes in C", p194 for the definition of the
c     spherical harmonics.
c..Input:  theta-- spherical coordinate
c          lmax -- angular order
c..Output: p(0:lmax,0:lmax) -- spherical coordinate
c..Note: in this subroutine exp(im*phi) is omitted
c.......................................................................
      subroutine spherical(theta,lmax,p,lsize)
      implicit real*4 (a-h, o-z)
      real*4 p(0:lsize,0:lsize)
      data fpi /12.56637061435916/
   
      x=cos(theta)

      y0    =sqrt(1.0/fpi)
      p(0,0)=y0
      p(1,0)=sqrt(3.0/fpi)*x
      fac   =2.0
      sqrx2 =sqrt(1.0-x*x)
      
      do  l=1,lmax
         y0=-sqrt((fac+1.0)/fac)*sqrx2*y0
         fac=fac+2.0
         p(l,l)=y0
         if(l.ne.lmax)p(l+1.d0,l)=sqrt(fac+1.0)*x*y0
      enddo

      do l=2,lmax
         do m=0,l-2
            xl2=2*l
            xlmm=l-m
            xlpm=l+m
            fac =sqrt((xl2+1.00)/(xlmm*xlpm))
            fac1=sqrt (xl2-1.00)
            fac2=sqrt((xlmm-1)*(xlpm-1)/(xl2-3.0))
            p(l,m)=(x*fac1*p(l-1,m)-fac2*p(l-2,m))*fac
         enddo
      enddo
      return
      end

      subroutine choles(a,g,b,y,x,n,nono)

      implicit real*4 (a-h, o-z)
      real*4 a(1),g(1)
      real*4 b(1),y(1),x(1)
c
c        a= row-wise p.d. symm. system  n*(n+1)/2
c        g= cholesky storage
c        b= r.h.s. vector               n
c        y= temp. vector
c        x= answer vector
c        n= system dimension
c        nono .gt. 0 is the level at which p.d. failed
c
c        (a,g) and (b,y,x) may be equivalenced.
c
c----------------------------------------------------------
c-----
c     first compute cholesky decomposition

      nono=0
      
      if(a(1).le.0.) then
      nono=1
      return
      endif
      
      g(1)=sqrt(a(1))
      y(1)=b(1)/g(1)

      do 400 i=2,n
      
      kz=(i*(i-1))/2
      g(kz+1)=a(kz+1)/g(1)
      sg=g(kz+1)**2
      y(i)=b(i)-g(kz+1)*y(1)
      
      if(i.gt.2) then
      
      jmax=i-1
      
      do 200 j=2,jmax
      
      gkz=a(kz+j)
      kj=(j*(j-1))/2
      kmax=j-1
      
      do 100 k=1,kmax
      gkz=gkz-g(kz+k)*g(kj+k)
100   continue

      g(kz+j)=gkz/g(kj+j)
      y(i)=y(i)-g(kz+j)*y(j)
      sg=sg+g(kz+j)**2
      
200   continue

      endif
      
      gkz=a(kz+i)-sg
      
      if(gkz.le.0.) then
      nono=i
      return
      endif
      
      g(kz+i)=sqrt(gkz)
      y(i)=y(i)/g(kz+i)
      
400   continue

      kz=(n*(n-1))/2
      x(n)=y(n)/g(kz+n)
      if(n.le.1) return

c-----
c     compute solution for particular rhs
      
      do 600 k=2,n
      
      i=n+1-k
      x(i)=y(i)
      jmin=i+1
      
      do 500 j=jmin,n
      kj=(j*(j-1))/2
      x(i)=x(i)-g(kj+i)*x(j)
500   continue

      kz=(i*(i+1))/2
      x(i)=x(i)/g(kz)
      
600   continue

      return
      end
c
      real*4  function geocen(arg)
c***  returns geocentric colat given geographic colat as arg
c***  n.b. fac=(1-f)**2
c***  argument in radians
      implicit real*4(a-h,o-z)
      data pi2,fac/1.570796326794895d0,0.993305621334896d0/
      temp = sin(arg)
      if(temp.lt.1.d-200) temp=1.d-200
      geocen=pi2-atan(fac*cos(arg)/temp)   
      return
      end

